#ifndef INCL_CONFIG_H
#define INCL_CONFIG_H

#include "if/ifcommon.h"
#include "instthnk.h"
#include "misc.h"

#include "Tablet.h"

class ConfigTablet : public IConfigPropSheet
{
public:
	ConfigTablet();
	bool Init(HINSTANCE _hinst, Tablet* _Tablet);  
	bool IFCALL Setup(IConfigPropBase*, PROPSHEETPAGE* psp);
	TABLET_CONFIG* GetConfig(void) { return &config; }

private:
	BOOL PageProc(HWND, UINT, WPARAM, LPARAM);
	static BOOL CALLBACK PageGate(ConfigTablet*, HWND, UINT, WPARAM, LPARAM);
	void InitDialog(HWND hdlg);
	void Update(HWND hdlg);
	void UpdateSlider(HWND hdlg);
	void EnableSlider(HWND hdlg);
	void Apply(HWND hdlg);
	void WritePrivateProfileInt(char* keyname, int keyvalue);
	BOOL Command(HWND hdlg, HWND hwctl, UINT nc, UINT id);

	HINSTANCE hinst;
	IConfigPropBase* base;
	InstanceThunk gate;
	char szIniFile[_MAX_PATH];
	TABLET_CONFIG config;
	TABLET_CONFIG config_disp;
	Tablet* tablet;
};

#endif // INCL_CONFIG_H
