#include "headers.h"
#include "mt20.h"

Mt20::Mt20()
{
	Reset();
}

Mt20::~Mt20()
{
}

void Mt20::Reset()
{
	x		= 0;
	y		= 0;
	valid	= false;
	buttons	= 0;
	sensitivity = 100;
}

void Mt20::Open(int _sensitivity, LOGCONTEXT _lc)
{
	Reset();
	lc = _lc;
	sensitivity = _sensitivity;
}

uint Mt20::SetValueTablet(byte* buf, PACKET& packet, bool _valid, DWORD _tick)
{
	const int max_x = 180;
	const int max_y = 140;
	uint	len = 0;
	if (_valid)
	{
		bool click = ((packet.pkButtons & 1) != 0);
		int nx = click ? Limit((180 * packet.pkX) / lc.lcInExtX, 180, 0) + 40 : x;
		int ny = click ? max_y - Limit((max_y * packet.pkY) / lc.lcInExtY, max_y, 0) + 50 : y;
		int button_changed = (buttons ^ packet.pkButtons) & 3;
		bool changed = ((button_changed & 2) != 0) ||
					   (((button_changed & 1) != 0) && (click || ((buttons & 1) != 0)));
		if (valid)
		{
			if ((_tick - tick) > 25 && (nx != x || ny != y || button_changed))
			{
				buf[0] = 0x40 | ((packet.pkButtons << 5) & 0x20) | 
						 ((packet.pkButtons << 3) & 0x10) |
						 ((ny >> 4) & 0x0c) | ((nx >> 6) & 0x03);
				buf[1] = nx & 0x3f;
				buf[2] = ny & 0x3f;
				len = 3;
			}
		}
		if (!valid || len)
		{
			x		= nx;
			y		= ny;
			buttons	= packet.pkButtons;
			tick	= _tick;
		}
	}
	valid = _valid;
	return len;
}

uint Mt20::SetValueMouse(byte* buf, PACKET& packet, bool _valid, DWORD _tick)
{
	uint	len = 0;
	if (_valid)
	{
		if (valid)
		{
			int vx = Limit((packet.pkX - x) * sensitivity / 100, 127, -128);
			int vy = Limit((y - packet.pkY) * sensitivity / 100, 127, -128);
			int button_changed = (buttons ^ packet.pkButtons) & 3;
			if ((_tick - tick) > 25 && (vx || vy || button_changed))
			{
				buf[0] = 0x40 | ((packet.pkButtons << 5) & 0x20) | 
						 ((packet.pkButtons << 3) & 0x10) |
						 ((vy >> 4) & 0x0c) | ((vx >> 6) & 0x03);
				buf[1] = vx & 0x3f;
				buf[2] = vy & 0x3f;
				len = 3;
			}
		}
		if (!valid || len)
		{
			x		= packet.pkX;
			y		= packet.pkY;
			buttons	= packet.pkButtons;
			tick	= _tick;
		}
	}
	valid = _valid;

	return len;
}
